# encoding: utf-8
class Admin::ApplicationFormItemContentsController < OrbitAdminController
  
  before_action ->(module_app = @app_title) { set_variables module_app }

  def initialize
    super
    @app_title = "application_form"
  end

  def index

    @application_form_item_contents = ApplicationFormItemContent.where(:application_form_main_id => params[:application_form_main_id]).page(params[:page]).per(10)
    @application_form = ApplicationFormMain.find(params[:application_form_main_id])

    @application_form_items = ApplicationFormItem.where(:_id.nin=> ApplicationFormItemContent.where(:application_form_main_id => params[:application_form_main_id]).collect{|t| t.application_form_item_id} ).collect{|a| [a.title,a.id]}
  end

  def new

    @contents = ApplicationFormItemContent.where(:application_form_main_id => params[:application_form_main_id]).collect{|t| t.application_form_item_id}
    @application_form_item_content = ApplicationFormItemContent.new

    @application_form_items = ApplicationFormItem.where(:_id.nin=> @contents).collect{|a| [a.title,a.id]}

  end

  def create

    application_form_item_content = ApplicationFormItemContent.new(application_form_item_content_params)

    application_form_item_content.create_user_id = current_user.id
    application_form_item_content.update_user_id = current_user.id

    application_form_item_content.save

    redirect_to params['referer_url']+"?application_form_main_id="+application_form_item_content.application_form_main_id

  end

  def edit

    @application_form_item_content = ApplicationFormItemContent.find(params[:id])
    @application_form = ApplicationFormMain.find(@application_form_item_content.application_form_main_id)

  end

  def update
    
    @application_form_item_content = ApplicationFormItemContent.find(params[:id])
    @application_form_item_content.update_attributes(application_form_item_content_params)

    redirect_to "/admin/application_form_item_contents?application_form_main_id="+@application_form_item_content.application_form_main_id

  end

  def destroy
    @application_form_item_content = ApplicationFormItemContent.find(params[:id])

    @application_form_item_content.destroy

    redirect_to "/admin/application_form_item_contents?application_form_main_id="+@application_form_item_content.application_form_main_id
  end

  private

  def application_form_item_content_params
    params.require(:application_form_item_content).permit!
  end
end
